
// CheckPOSInVID.cpp : implementation file
//

#include "stdafx.h"
#include "CheckPOSInVID.h"
#include "CheckPOSInVIDDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CCheckPOSinVIDDlg dialog




CCheckPOSinVIDDlg::CCheckPOSinVIDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCheckPOSinVIDDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCheckPOSinVIDDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_DATETIMEPICKER1, m_startTime);
   DDX_Control(pDX, IDC_DATETIMEPICKER2, m_endTime);
}

BEGIN_MESSAGE_MAP(CCheckPOSinVIDDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
   ON_MESSAGE(NOTIFY_SHOW, OnTrayIcon) 
	//}}AFX_MSG_MAP
   ON_WM_NCPAINT()
   ON_BN_CLICKED(IDC_BUTTON_START, &CCheckPOSinVIDDlg::OnBnClickedButtonStart)
   ON_BN_CLICKED(IDC_CHECK_START, &CCheckPOSinVIDDlg::OnBnClickedCheckStart)
   ON_BN_CLICKED(IDC_CHECK_END, &CCheckPOSinVIDDlg::OnBnClickedCheckEnd)
   ON_MESSAGE(WM_CHECK_DONE, &CCheckPOSinVIDDlg::OnCheckDone) 
END_MESSAGE_MAP()


// CCheckPOSinVIDDlg message handlers

BOOL CCheckPOSinVIDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
   if (runOnlyOne() == FALSE)
   {
      return TRUE;
   }

   m_startTime.SetFormat(_T("yyyy-MM-dd HH:mm:ss"));
   m_endTime.SetFormat(_T("yyyy-MM-dd HH:mm:ss"));
   ((CButton*)GetDlgItem(IDC_CHECK_START))->SetCheck(0);
   ((CButton*)GetDlgItem(IDC_CHECK_START))->SetCheck(0);
   GetDlgItem(IDC_DATETIMEPICKER1)->EnableWindow(FALSE);
   GetDlgItem(IDC_DATETIMEPICKER2)->EnableWindow(FALSE);


   ToTray();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCheckPOSinVIDDlg::OnCancel() 
{ 
   if ( !GetDlgItem(IDC_BUTTON_START)->IsWindowEnabled() )
   {
      m_checkOSD.StopCheck();
   }
   //ɾͼ 
   NOTIFYICONDATA nid; 
   nid.hWnd=this->m_hWnd; 
   nid.uID=IDR_MAINFRAME; 
   Shell_NotifyIcon(NIM_DELETE, &nid); 
   CDialog::OnCancel(); 
} 


void CCheckPOSinVIDDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
   if (SC_MINIMIZE == nID) 
   { 
      ToTray();
      return; 
   } 
   
   
   if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCheckPOSinVIDDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCheckPOSinVIDDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


LRESULT CCheckPOSinVIDDlg::OnTrayIcon(WPARAM wParam, LPARAM lParam) 
{ 
   if (wParam != IDR_MAINFRAME) 
   { 
      return 1; 
   } 

   switch(lParam) 
   { 
   case WM_RBUTTONUP: 
      { 
         //Ҽʱݲ˵ֻһرա 

         //һʽ˵ 
         //Ӳ˵رաϢWM_CLOSEڣ    
         //أ  
         CMenu menu; 
         menu.CreatePopupMenu(); 
         menu.AppendMenu(MF_STRING, ID_APP_EXIT, _T("Exit")); 

         //õλ 
         LPPOINT lpoint= new tagPOINT; 
         ::GetCursorPos(lpoint); 

         //ȷʽ˵λ    
         menu.TrackPopupMenu(TPM_LEFTALIGN, lpoint->x, lpoint->y,this); 

         //Դ 
         HMENU   hmenu=menu.Detach(); 
         menu.DestroyMenu(); 

         delete lpoint; 
         lpoint = NULL; 

         break; 
      } 
   case WM_LBUTTONDBLCLK: 
      { 
         //˫Ĵ 
         ShowWindow(SW_SHOW); 
         //ö 
         SetForegroundWindow(); 
         break; 
      } 
   } 

   return 0; 
} 


void CCheckPOSinVIDDlg::ToTray()
{
   NOTIFYICONDATA nid; 
   nid.cbSize = (DWORD)sizeof(NOTIFYICONDATA);    
   nid.hWnd = this->m_hWnd;    
   nid.uID = IDR_MAINFRAME;    
   nid.uFlags = NIF_ICON|NIF_MESSAGE|NIF_TIP   ;    
   nid.uCallbackMessage = NOTIFY_SHOW;//ԶϢ 
   nid.hIcon = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME));    
   _tcscpy_s(nid.szTip, _T("CheckPOSInVid"));//Ϣʾ 

   Shell_NotifyIcon(NIM_ADD,&nid);//ͼ 
   ShowWindow(SW_HIDE);//
}

//void CCheckPOSinVIDDlg::OnNcPaint()
//{
//   // TODO: Add your message handler code here
//   // Do not call CDialog::OnNcPaint() for painting messages
//   static int i = 2;
//   if (i > 0)
//   {
//      i--;
//      ShowWindow(SW_HIDE);
//   }
//   else
//      CDialog::OnNcPaint();
//}


BOOL CCheckPOSinVIDDlg::runOnlyOne()
{
   HANDLE hMutex = CreateMutex(NULL, true, _T("CheckPOSInVid")); 
   if (hMutex)
   {
      if (GetLastError() == ERROR_ALREADY_EXISTS)
      {        
         CloseHandle(hMutex);
         hMutex = NULL;
         AfxMessageBox(_T("CheckPOSInVid.exe already run!"));
         return FALSE;
      }
   }
   else
   {      
      return FALSE;
   }  
   return TRUE;
}
void CCheckPOSinVIDDlg::OnBnClickedButtonStart()
{
   // TODO: Add your control notification handler code here
   UpdateData(TRUE);
   if ( !m_checkOSD.Inital() )
   {
      AfxMessageBox(_T("Initial error!"));
      OnCancel(); 
   }
   else
   {
      OnBnClickedCheckStart();
      OnBnClickedCheckEnd();
      m_checkOSD.m_startTime = m_lStartTime;
      m_checkOSD.m_endTime = m_lEndtime;
      m_checkOSD.m_hwnd = GetSafeHwnd();
      m_checkOSD.StartCheck();
      GetDlgItem(IDC_BUTTON_START)->EnableWindow(FALSE);
   }
}



void CCheckPOSinVIDDlg::OnBnClickedCheckStart()
{
   if (  BST_CHECKED == IsDlgButtonChecked( IDC_CHECK_START)  )
   {
      GetDlgItem(IDC_DATETIMEPICKER1)->EnableWindow(TRUE);
      CTime tm;
      m_startTime.GetTime(tm);
      m_lStartTime = tm.GetTime();
   }
   else
   {
      GetDlgItem(IDC_DATETIMEPICKER1)->EnableWindow(FALSE);
      m_lStartTime = 0;
   }

}

void CCheckPOSinVIDDlg::OnBnClickedCheckEnd()
{
   if (  BST_CHECKED == IsDlgButtonChecked( IDC_CHECK_END)  )
   {
      GetDlgItem(IDC_DATETIMEPICKER2)->EnableWindow(TRUE);
      CTime tmEnd;
      m_endTime.GetTime(tmEnd);
      m_lEndtime = tmEnd.GetTime();
   }
   else
   {
      GetDlgItem(IDC_DATETIMEPICKER2)->EnableWindow(FALSE);
      m_lEndtime = 0;
   }
}

LONG CCheckPOSinVIDDlg::OnCheckDone(WPARAM w,LPARAM l)
{
   AfxMessageBox(_T("Check Done!")); 
   m_checkOSD.StopCheck();
   m_checkOSD = CCheckOSD();
   GetDlgItem(IDC_BUTTON_START)->EnableWindow(TRUE);
   return 0;
}