/*******************************************************************************
Copyright (c) 1983-2010 Advantech Co., Ltd.
********************************************************************************
THIS IS AN UNPUBLISHED WORK CONTAINING CONFIDENTIAL AND PROPRIETARY INFORMATION
WHICH IS THE PROPERTY OF ADVANTECH CORP., ANY DISCLOSURE, USE, OR REPRODUCTION,
WITHOUT WRITTEN AUTHORIZATION FROM ADVANTECH CORP., IS STRICTLY PROHIBITED. 

================================================================================
REVISION HISTORY
--------------------------------------------------------------------------------
$Log: 

$NoKeywords:  $
*/

#ifndef IVIDEO_STREAM_PARSER_H
#define IVIDEO_STREAM_PARSER_H

class IVideoStreamParser
{
public:
   virtual ~IVideoStreamParser () {}
   virtual bool Open() = 0;
   virtual void Close() = 0;

   virtual bool Parse(LPBYTE lpData, DWORD dwDataSize, bool& isKeyFrame, bool &isFragment) = 0;

   virtual int GetWidth() = 0;   //dataķֱ
   virtual int GetHeight() = 0;
};

IVideoStreamParser* CreateVideoStreamParser(DWORD dwFourCC);
void DestroyVideoStreamParser(IVideoStreamParser *parser);

#pragma comment ( lib, "AdvStreamParse.lib" )

#endif // IVIDEO_STREAM_PARSER_H